﻿using AcademicProgressBusinessLogic.Enums;
using DepartmentBusinessLogic.Enums;
using ModuleTools.Attributes;
using ModuleTools.BindingModels;
using System;
using System.ComponentModel.DataAnnotations;

namespace AcademicProgressBusinessLogic.BindingModels
{

    /// <summary>
	/// Получение записи успеваемости студента
	/// </summary>  
    public class StudentAcademicProgressGetBindingModel : GetBindingModel
    {
        public Guid? StudentId { get; set; }
        public Guid? DisciplineId { get; set; }

    }

    /// <summary>
	/// Сохранение записи успеваемости студента
	/// </summary>
    public class StudentAcademicProgressSetBindingModel : SetBindingModel
    {
        [Required(ErrorMessage = "required")]
        [MapConfiguration("StudentId")]
        public Guid StudentId { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("DisciplineId")]
        public Guid DisciplineId { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("Semester")]
        public Semester Semester { get; set; }

        [Required(ErrorMessage = "required")]
        [MapConfiguration("Score")]
        public ExamScores Score { get; set; }


        [Required(ErrorMessage = "required")]
        [MapConfiguration("AffixingDate")]
        public DateTime AffixingDate { get; set; }

        /// <summary>
        /// Является повышением оценки
        /// </summary>
        [MapConfiguration("IsIncreaseScore")]
        public bool IsIncreaseScore { get; set; }

        /// <summary>
        /// Является сдачей по направлению
        /// </summary>
        [MapConfiguration("IsResit")]
        public bool IsResit { get; set; }

    }
}
