﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

namespace DatabaseCore.Migrations
{
    public partial class AddStudentAcademicProgress : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "StudentAcademicProgress",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    StudentId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    DisciplineId = table.Column<Guid>(type: "uniqueidentifier", nullable: false),
                    Semester = table.Column<int>(type: "int", nullable: false),
                    StudentAcademicProgressId = table.Column<Guid>(type: "uniqueidentifier", nullable: true),
                    Score = table.Column<string>(type: "nvarchar(max)", nullable: false),
                    AffixingDate = table.Column<DateTime>(type: "datetime2", nullable: false),
                    IsIncreaseScore = table.Column<bool>(type: "bit", nullable: false),
                    IsResit = table.Column<bool>(type: "bit", nullable: false),
                    DateCreate = table.Column<DateTime>(type: "datetime2", nullable: false),
                    DateDelete = table.Column<DateTime>(type: "datetime2", nullable: true),
                    IsDeleted = table.Column<bool>(type: "bit", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_StudentAcademicProgress", x => x.Id);
                    table.ForeignKey(
                        name: "FK_StudentAcademicProgress_Disciplines_DisciplineId",
                        column: x => x.DisciplineId,
                        principalTable: "Disciplines",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_StudentAcademicProgress_Students_StudentId",
                        column: x => x.StudentId,
                        principalTable: "Students",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateIndex(
                name: "IX_StudentAcademicProgress_DisciplineId",
                table: "StudentAcademicProgress",
                column: "DisciplineId");

            migrationBuilder.CreateIndex(
                name: "IX_StudentAcademicProgress_StudentId_DisciplineId_Semester",
                table: "StudentAcademicProgress",
                columns: new[] { "StudentId", "DisciplineId", "Semester" },
                unique: true);
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "StudentAcademicProgress");
        }
    }
}
